#ifndef _LAPPCONTROL_CLASS_H_
#define _LAPPCONTROL_CLASS_H_

#include <lcl.h>

class LCL_EXPORT LApplicationControl_Class;

#include <lcl/lappcontrol.h>
#include <lcl/lfifo.h>
#include <lcl/lsem.h>
#include <lcl/lthread.h>
#include <lcl/lqueue.h>
#include <lcl/lqueue_base.h>

class LCL_EXPORT LApplicationControl_Class {
 protected:
  class LCL_EXPORT Request {
  protected:
    LApplicationControl_Base * myControl;
    LManagedPointer<LApplicationControl_Base::Request> myRequest;
  public:
    LApplicationControl_Base::Packet getData() const;
    void sendReply ( LApplicationControl_Base::Packet const & );

    Request ( LApplicationControl_Base *, LManagedPointer<LApplicationControl_Base::Request> );
  };

 protected:
  LQueueReaderDynamic < LManagedPointer<Request> > requestQueue;
  LQueueSender < LManagedPointer<Request> > requestSender;
  LSemaphore finishLock;
  LSemaphore startLock;
  bool running;

  LManagedPointer<Request> fetchRequest ();

  LMethodThreadFn<LApplicationControl_Class> runnerFn;

 public:

  LApplicationControl_Class ();
  virtual ~LApplicationControl_Class ();

  void queueRequest ( LApplicationControl_Base *, LManagedPointer<LApplicationControl_Base::Request> request );  

  void start ( void );

  void xrunner ( void );
  virtual void runner ( void ) = 0;
};

class LApplicationControl_DummyClass : public LApplicationControl_Class {
 protected:
 public:
  virtual void runner ( void );
};

class LApplicationControl_TraceClass : public LApplicationControl_Class {
 protected:
 public:
  virtual void runner ( void );
};

#endif
