/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* ****************************************************************************
   |      File: lcgi.h
   |      Contains: class definition for LCGI
   |      Created: 21.03.1998
   |      Last Changed: 21.03.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ====>> See also the ChangeLog in lcgi.cc <<==== */

#ifndef _L_CGI_H_
#define _L_CGI_H_

#include <lcl.h>
#include <lcl/lobject.h>
#include <lcl/lconfsys.h>
#include <lcl/lconfparser.h>
#include <lcl/lstring.h>
#include <lcl/lbuffer.h>
#include <lcl/lsockaddr.4inet.h>

class LCL_EXPORT LCGI : public LObject {
  CLASSNAME("LCGI");

 protected:
  LConfigSystem query;

 public:

  // ************ Constructors ************

  LCGI();
  LCGI ( LConfigParser * );


  // ************ send *****************
  void sendHeader ( LString const & contentType = "text/html" );
  void sendHeader ( LString const & contentType, unsigned long size, LString const & add = "");
  void sendHeader ( LString const & contentType, LBuffer & buffer, LString const & add = "" );

  void sendContent ( LBuffer const & );

  void sendFile ( LString const &, LString const & p1 = "", LString const & p2 = "", LString const & p3 = "", LString const & p4 = "", LString const & p5 = "", \
	              LString const & p6 = "", LString const & p7 = "", LString const & p8 = "", LString const & p9 = "" );

  // ************ Parameter funcs ********

  int has ( LString const & key );
  LString get ( LString const & );

  // ************ Env Vars ***************

  LString method();
  LString docRoot();
  LString remoteHost();
  LSockAddr4Inet remoteAddr();
  LString referer();
};

#endif

