/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LCL_TEST_H_
#define _LCL_TEST_H_

#include <lcl.h>

class LCL_EXPORT LCLTestInfo {
 protected:
  unsigned long allTests, okTests;
 public:
  LCLTestInfo ();

  void addResult ( bool success );
  void addSuccess ( void );
  void addFailure ( void );

  void dumpResults ( void );
};

class LCL_EXPORT LCLTester  : public LCLTestInfo {
protected:
public:

  template <class Type>
  bool test ( Type const & expected, Type const & result )
  {
    bool rc = (expected == result);
    addResult ( rc );
    return rc;
  }
  template <class Type>
  void test ( char const * name, Type const & expected, Type const & result )
  {
    cout << "Test: '" << name << "' Result: '" << result << "' -> Excpected: '" << expected << "'";
    if ( !test ( expected, result ) )
      {
	cout << "  <<--- FAILED!!!";
      }
    cout << endl << flush;
  }
};

#define LSTR_TEST(t,f,e) (t).test ( (#f), LString((e)), LString((f)) )
#define LSTR_TEST_A(t,a,f,e) (f); (t).test ( (#f), LString((e)), LString((a)) )

#endif
