/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LCL_TYPES_H_
#define _LCL_TYPES_H_

#include <lcl/lcl_config.h>

#undef LCL_HAVE_INT8
#undef LCL_HAVE_INT16
#undef LCL_HAVE_INT32
#undef LCL_HAVE_INT64

#if ( SIZEOF_CHAR == 1 ) && ! defined ( LCL_HAVE_INT8 )
typedef signed char lint8;
typedef unsigned char luint8;

#define LCL_HAVE_INT8

#endif

#if ( SIZEOF_SHORT == 2 ) && ! defined ( LCL_HAVE_IN16 )
typedef signed short lint16;
typedef unsigned short luint16;

#define LCL_HAVE_INT16

#endif

#if ( SIZEOF_INT == 2 ) && ! defined ( LCL_HAVE_INT16 )
typedef signed int lint16;
typedef unsigned int luint16;

#define LCL_HAVE_INT16

#endif

#if ( SIZEOF_INT == 4 ) && ! defined ( LCL_HAVE_INT32 )
typedef signed int lint32;
typedef unsigned int luint32;

#define LCL_HAVE_INT32

#endif

#if ( SIZEOF_LONG == 4 ) && ! defined ( LCL_HAVE_INT32 )
typedef signed long lint32;
typedef unsigned long luint32;

#define LCL_HAVE_INT32

#endif

#if ( SIZEOF_LONG_LONG == 8 ) && ! defined ( LCL_HAVE_INT64 )
typedef signed long long lint64;
typedef unsigned long long luint64;

#define LCL_HAVE_INT64

#endif

#if ( SIZEOF___INT64 == 8 ) && ! defined ( LCL_HAVE_INT64 )
typedef signed __int64 lint64;
typedef unsigned __int64 luint64;

#define LCL_HAVE_INT64

#endif

#ifndef LCL_HAVE_INT8
#error "Don't have any type for 8 bit integer"
#endif

#ifndef LCL_HAVE_INT16
#error "Don't have any type for 16 bit integer"
#endif

#ifndef LCL_HAVE_INT32
#error "Don't have any type for 32 bit integer"
#endif

#ifndef LCL_HAVE_INT64
#warning "Dont' have any type for 64 bit integer"
#endif

typedef luint8 lu8_char;
typedef luint16 lu16_char;
typedef luint32 lu32_char;

typedef lu8_char lchar;

#endif
