/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LCONFIGMODULE_H_
#define _LCONFIGMODULE_H_

#include <lcl.h>

class LCL_EXPORT LConfigReader;
class LCL_EXPORT LConfigWriter;

#include <lcl/liostream.h>
#include <lcl/lconfsys.h>
#include <lcl/lfile.h>
#include <lcl/lpointer.h>

class LCL_EXPORT LConfigReader {
 protected:
 public:
  virtual void read ( LConfigSystem & config ) const = 0;
};

class LCL_EXPORT LConfigWriter {
 protected:
 public:
  virtual void write ( LConfigSystem & config ) const = 0;
};

class LCL_EXPORT LConfigReader_default : public LConfigReader {
 protected:
  LIStream * stream;
  LManagedPointer<LFile> myFile;
  LManagedPointer<LIStream> myStream;

 public:
  LConfigReader_default ( LIStream & );
  LConfigReader_default ( LString const & );

  virtual void read ( LConfigSystem & config ) const;
};

class LCL_EXPORT LConfigWriter_default : public LConfigWriter {
 protected:
  LOStream & stream;
 public:
  LConfigWriter_default ( LOStream & );
  virtual void write ( LConfigSystem & config ) const;
};

#endif
