#ifndef _LDATETIME_H_
#define _LDATETIME_H_

#include <lcl.h>
#include <lcl/lstring.h>

#include <time.h>
#include <lcl/lvcs.h>

class LCL_EXPORT LDateTime {
 LVCS_DECLARE;

 protected:
  time_t value;

 public:
  LDateTime ();
  LDateTime ( time_t );
  LDateTime ( LString const &, LString const = "auto" );
  LDateTime ( tm );
  LDateTime ( tm * _tm );

  static LDateTime now ();

  long getHours () const;
  void setHours ( long );
  long getMinutes () const;
  void setMinutes ( long );
  long getSeconds () const;
  void setSeconds ( long );

  long getYear () const;
  void setYear ( long );
  long getMonth () const;
  void setMonth ( long );
  long getDay () const;
  void setDay ( long );
  long getDayOfYear () const;

  long inSeconds () const;
  long inMinutes () const;
  long inHours () const;
  long inDays () const;
  long inMonths () const;
  long inYears () const;

  operator time_t() const;
  operator time_t*();
  operator tm () const;
  operator tm* () const;

  void dump () const;

  LString asString ( LString const & format = LString() ) const;

  LDateTime operator- (LDateTime const &) const;
}; 

#endif
