#include <ldbsystem.h>

#include <mysql/mysql.h>

#include <lmutex.h>

class LDBQuery_MySQL;

class LDBDriver_MySQL : public LDBDriver {
  LHash<LString,LString> configHash;

  friend class LDBQuery_MySQL;

 protected:
  MYSQL mysql;
  bool valid;
  LMutex lock;

  virtual LManagedPointer<LDBQuery> createQuery ();

 public:

  LDBDriver_MySQL ( LHash<LString,LString> const & vars );
  ~LDBDriver_MySQL ();

  //  LDBQuery * query ( LString const & );

  virtual bool connect ();
  virtual bool disconnect ();

  virtual bool connected () const;

};

class LDBQuery_MySQL : public LDBQuery {
 protected:

  MYSQL_RES * result;
  MYSQL_ROW the_row;
  LDBDriver_MySQL & driver;

 public:
  LDBQuery_MySQL ( LDBDriver_MySQL & );
  LDBQuery_MySQL ( LDBDriver_MySQL &, LString const & sql );
  virtual ~LDBQuery_MySQL ();

  //  virtual bool prepare ( LString const & );
  //  virtual bool exec ();
  virtual bool exec ( LString const & );
  //  virtual bool exec ( LHash<LString, LString> const & );

  virtual long numFields () const;
  virtual long numRows () const;

  virtual bool fetchNext ( LHash<LString, LString> & );
  virtual bool fetchNext ();
          
  virtual LString getField ( long ) const;
  virtual LString getField ( LString const& ) const;

  virtual LString getFieldName ( long ) const;
  virtual long getFieldIdx ( LString const & ) const;

  // liefert exec-wert zurck
  virtual bool hasResult () const;
};
