/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LEMIT_X_1_H_
#define _LEMIT_X_1_H_

template < class Parameter1 >
class LCL_EXPORT LBasicSlot1 : public LBasicSlot {
 protected:
 public:

  virtual ~LBasicSlot1 () {};

  virtual void fire ( Parameter1 ) = 0;
};

template < class Parameter1 >
class LCL_EXPORT LCSlot1 : public LBasicSlot1<Parameter1> {
 public:
  void (*callback) ( Parameter1 );
 public:
  LCSlot1 ( void (*_callback)( Parameter1 ) );
  virtual void fire ( Parameter1 );

  virtual ~LCSlot1 () {};
};

template < class Parameter1 >
inline LCSlot1<Parameter1>::LCSlot1 ( void (*_callback)( Parameter1 ) ) :
  callback ( _callback )
{
}

template < class Parameter1 >
inline void LCSlot1<Parameter1>::fire ( Parameter1 p1 )
{
  if ( callback && isActive() )
    callback ( p1 );
}

template < class Object, class Parameter1 >
class LCL_EXPORT LMethodSlot1 : public LBasicSlot1<Parameter1> {
 public:
  Object & object;
  void (Object::*callback) ( Parameter1 );

 public:

  virtual ~LMethodSlot1 () {};

  LMethodSlot1 ( Object & );
  virtual void fire ( Parameter1 );
};

template < class Object, class Parameter1 >
LMethodSlot1<Object, Parameter1>::LMethodSlot1 ( Object & obj ) :
  object ( obj ),
  callback ( NULL )
{
}

template < class Object, class Parameter1 >
inline void LMethodSlot1<Object,Parameter1>::fire ( Parameter1 p1  )
{
  if ( (callback) && isActive() )
    (object.*callback) ( p1 );
}

template < class Parameter1 >
class LCL_EXPORT LEmitter1 : public LBasicEmitter {
 protected:
 public:
  void emit ( Parameter1 );
};

template < class Parameter1 >
inline void LEmitter1<Parameter1>::emit ( Parameter1 p1 )
{

  LSet < LManagedPointer<LBasicSlot> > myList = callbackList;

  LManagedPointer<LCursor> cursor = myList.createCursor ();

  for ( cursor->setToFirst(); cursor->isValid(); cursor->setToNext() )
    {
      LManagedPointer<LBasicSlot> slot = myList.elementAt ( cursor );

      LBasicSlot1<Parameter1> * slot1 = (LBasicSlot1<Parameter1>*)slot.getPtr();

      if ( slot->isActive () )
	{
	  slot1 -> fire ( p1 );
	}
      else
	{
	  callbackList.removeElement ( slot );
	}
      
    }

  
}

#ifdef _LCL_COMPILER_MSVC_

template <class Object, class Parameter1 >
inline LSlotConnection connect_emitter_1 ( void (Object::*func)(Parameter1), Object & object, LEmitter1<Parameter1> & emitter )
{
  LMethodSlot1<Object,Parameter1> * slot = new LMethodSlot1<Object,Parameter1> ( object );
  slot->callback = func;
  return emitter.addSlot ( slot );
}

template <class Parameter1 >
inline LSlotConnection connect_emitter_1 ( void (*func)(Parameter1), LEmitter1<Parameter1> & emitter )
{
  LCSlot1<Parameter1> * slot = new LCSlot1<Parameter1> ( func );
  return emitter.addSlot ( slot );
}

#else

#define connect_emitter_1 connect_emitter


template <class Object, class Parameter1 >
inline LSlotConnection connect_emitter ( void (Object::*func)(Parameter1), Object & object, LEmitter1<Parameter1> & emitter )
{
  LMethodSlot1<Object,Parameter1> * slot = new LMethodSlot1<Object,Parameter1> ( object );
  slot->callback = func;
  return emitter.addSlot ( slot );
}

template <class Parameter1 >
inline LSlotConnection connect_emitter ( void (*func)(Parameter1), LEmitter1<Parameter1> & emitter )
{
  LCSlot1<Parameter1> * slot = new LCSlot1<Parameter1> ( func );
  return emitter.addSlot ( slot );
}
#endif


#endif
