#ifndef _LEMIT_X_H_
#define _LEMIT_X_H_

#include <lcl.h>

#include <lcl/lpointer.h>
#include <lcl/lset.h>

class LCL_EXPORT LSlotConnection;

class LCL_EXPORT LBasicSlot {
 protected:
  bool active;
 public:

  virtual ~LBasicSlot ();

  LBasicSlot ();
  void disconnect ( void );

  bool isActive () const;
};

class LCL_EXPORT LBasicEmitter {
 protected:
  LSet < LManagedPointer < LBasicSlot > > callbackList;

 public:

  virtual LSlotConnection addSlot ( LManagedPointer < LBasicSlot > slot );
  virtual void removeSlot ( LManagedPointer < LBasicSlot > slot );

  virtual ~LBasicEmitter ();
};

class LCL_EXPORT LSlotConnection {
 protected:
  LManagedPointer<LBasicSlot> slot;
 public:
  LSlotConnection ( );
  LSlotConnection ( LManagedPointer<LBasicSlot> slot );

  void disconnect ( void );

  virtual ~LSlotConnection ();
};

#include "lemitx.0.h"
#include "lemitx.1.h"
#include "lemitx.2.h"

#endif
