#ifndef _LFILE_H_
#define _LFILE_H_

#include <lcl.h>
#include <lcl/lfiledesc.h>
#include <lcl/lfdlayer.h>

/*!
 * \ingroup FileDescriptors
 * \class LFile
 * \brief A file class
 * \author Jens Reimann <ctron@dentrassi.de>
 */
class LCL_EXPORT LFile : public LFileDesc {
 public:
  //  enum AccessType { read = 0x01, write = 0x02, append = 0x4, create = 0x08, failExists = 0x10, truncate = 0x20 };

 protected:

  LFileDescriptor open ( LString const & filename, int accessType, mode_t om );

 public:

  //  LFile ( LString const & filename, int = read | write | create );

  //! Create a new file instance with no file assigned
  LFile ();

  //! Create a new file instance by opening a file
  LFile ( LString const & filename, int = LFDManager::read | LFDManager::write | LFDManager::create, mode_t om = 0 );

  virtual ~LFile ();
};

#endif
