/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

/* LCL - The Linux Class Library
 * Copyright (C) 1998-2002 Jens Reimann
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _LFILESTREAM_H_
#define _LFILESTREAM_H_

#include <lcl.h>
#include <lcl/liostream.h>
#include <lcl/lfiledesc.h>

#ifdef _LCL_COMPILER_MSVC_
# pragma warning (disable: 4250)
#endif

class LCL_EXPORT LFIStream : virtual public LIStream {
 protected:
  LFileDesc handle;

  /*
  void setBlock ( bool ) ;
  bool getBlock ( ); 
  */

 public:

  LFIStream ( );
  //  LFIStream ( LFileDescriptor handle );
  LFIStream ( LFileDesc const & );

  //  virtual bool mayRead (); 
  virtual int read ( char & c );
  virtual int read ( void * ptr, unsigned long );
};

class LCL_EXPORT LFOStream : virtual public LOStream {
 protected:
  LFileDesc handle;

  /*
  void setBlock ( bool );
  bool getBlock ( );
  */

 public:

  LFOStream ( );
  //  LFOStream ( LFileDescriptor handle );
  LFOStream ( LFileDesc const & );

  //  virtual bool mayWrite ();

  virtual int write ( char c );
  virtual int write ( void const *, unsigned long );
};

class LCL_EXPORT LFIOStream : public LFIStream, public LFOStream, virtual public LIOStream  {
 public:
  LFIOStream ( );
  //  LFIOStream ( LFileDescriptor handle );
  LFIOStream ( LFileDesc const & );
};

#endif
