#ifndef _LIMAGE_PPM_H_
#define _LIMAGE_PPM_H_

#include <lcl/limage.h>

class LCL_EXPORT LImageReader_PPM : public LImageReader {
 protected:
 public:

  bool read_as_rgb_ascii ( LImage & image, LIStream & stream ) const;
  bool read_as_rgb_binary ( LImage & image, LIStream & stream ) const;

  bool read_as_gray_ascii ( LImage & image, LIStream & stream ) const;
  bool read_as_gray_binary ( LImage & image, LIStream & stream ) const;

  virtual bool impl_read ( LImage & image, LIStream & stream ) const;
};

class LCL_EXPORT LImageWriter_PPM : public LImageWriter {
 public:
  enum ModeFlag { BINARY, ASCII };
  
 protected:
  ModeFlag mode;
  
 public:

  LImageWriter_PPM ( ModeFlag _mode = ASCII );

  bool write_as_rgb_ascii ( LImage const & image, LOStream & stream ) const;
  bool write_as_rgb_binary ( LImage const & image, LOStream & stream ) const;

  bool write_as_gray_ascii ( LImage const & image, LOStream & stream ) const;
  bool write_as_gray_binary ( LImage const & image, LOStream & stream ) const;

  virtual bool impl_write ( LImage const & image, LOStream & stream ) const;
};

#endif
