#ifndef _LREVISION_H_
#define _LREVISION_H_

typedef struct _LFeatureRecord {
  char * name;
  _LFeatureRecord * nextFeature;
} LFeatureRecord;

typedef struct _LRevisionRecord {
  char * version;
  char * description;
  _LRevisionRecord * nextRevision;
} LRevisionRecord;

typedef struct _LModuleRecord {
  LRevisionRecord * firstRevision;
  LFeatureRecord * firstFeature;

  _LModuleRecord * nextModule;

  char * name;
} LModuleRecord;

#include <lcl/liostream.h>

class LModuleInfo {
 public:
  static void dump ( LOStream & os );
};

class LCL_EXPORT LFeature {
 public:
  LFeature ( char const * module, char const * name );
};

class LCL_EXPORT LRevision {
 public:
  LRevision ( char const * module, char const * version, char const * description );
};

#ifdef LCL_NOVERSION
#define LREVISION(m,r,v,d)
#define LFEATURE(m,f,n)
#else
#define LREVISION(m,r,v,d) LRevision __revision_##r ( m, v, d );
#define LFEATURE(m,f,n) LFeature __feature_##f ( m, n );
#endif

#endif
