#ifndef _LSOCKADDR_H_
#define _LSOCKADDR_H_

class LSockAddr;

#include <lcl.h>

#include <lcl/lstring.h>

class LCL_EXPORT LSockAddr {
 protected:
  LString nameLookupCache;

  //! Looks up the name (if possible ) of the address
  virtual LString nameLookup () const = 0;
  //! Looks up the number (if possible) of the address
  virtual LString numLookup () const = 0;

 public:

  LSockAddr ();
  LSockAddr ( LString const & );

  //! Converts the address to a LString
  LString asString ( bool doNameLookup = true ) const;

  //! Invalidates the Lookup cache (don't use!)
  void invalidate ();

  virtual operator sockaddr () const = 0;
  virtual operator sockaddr* () = 0;
  virtual operator sockaddr const * () const = 0;

  virtual L_ADDRLEN_T length () const = 0;

  virtual LString dump () const = 0;

  virtual long getFamily () const;
};

LCL_EXPORT NAMESPACE_STD(ostream) & operator << ( NAMESPACE_STD(ostream) &, LSockAddr const & );

#endif
