#ifndef _LSTREAMPROXY_H_
#define _LSTREAMPROXY_H_

#ifdef _MSC_VER
#pragma warning (disable: 4250)
#endif


#include <lcl.h>
#include <lcl/liostream.h>

class LCL_EXPORT LIStreamProxy;
class LCL_EXPORT LOStreamProxy;

LCL_EXPORT extern LOStreamProxy lout;
LCL_EXPORT extern LOStreamProxy lerr;
LCL_EXPORT extern LIStreamProxy lin;

class LCL_EXPORT LIStreamProxy : virtual public LIStream {
 protected:
  NAMESPACE_STD(istream) & in_stream;

 public:
  LIStreamProxy ( NAMESPACE_STD(istream) & );

  int read ( char & c );
  int read ( void * ptr, unsigned long );

  bool mayRead ();
};

class LCL_EXPORT LOStreamProxy : virtual public LOStream {
  friend LOStreamProxy & flush ( LOStreamProxy & );
 protected:
  NAMESPACE_STD(ostream) & out_stream;

 public:
  LOStreamProxy ( NAMESPACE_STD(ostream) & );

  int write ( char c );
  int write ( void * const ptr, unsigned long );

  bool mayWrite ();

  virtual void flush ();
};

class LCL_EXPORT LIOStreamProxy : virtual public LIOStream, virtual public LIStreamProxy, virtual public LOStreamProxy {
 protected:
  NAMESPACE_STD(iostream) & inout_stream;

 public:
  LIOStreamProxy ( NAMESPACE_STD(iostream) & );
};

#ifdef _MSC_VER
#pragma warning (default: 4250)
#endif

#endif
