#ifndef _LTRACECHANNEL_DGRAM_H
#define _LTRACECHANNEL_DGRAM_H

#include <lcl/ltracechannel.h>

#include <lcl/lsocket.h>
#include <lcl/lsockaddr.4inet.h>

typedef struct {
  char appName[256];
  char moduleName[256];
  char message[8*1024];

  unsigned long pid, tid;
} LTracePacket;

/*!
 * \class LTraceChannel_DGRAM
 * \author Jens Reimann
 * \ingroup Tracing
 * \brief Tracing module using datagram (UDP packets)
 *
 * This tracing module uses datagrams (UDP packets) to send out the information which should be traced.
 * Packets may be shown in another application (like LWinTrace).
 */

class LTraceChannel_DGRAM : public LTraceChannel {
 protected:
  LSocket4Inet socket;
  LSockAddr4Inet dstAddr;
  bool valid;

 public:
  LTraceChannel_DGRAM ( LHash<LString,LString> & );
  virtual void trace ( const char * module, const char * message );
};

#endif
