#ifndef _LCL_TRACE_FUNC_H_
#define _LCL_TRACE_FUNC_H_

#include <lcl.h>

class LCL_EXPORT LTraceFunc;

#include <lcl/lhash.h>
#include <lcl/lheap.h>
#include <lcl/lmutex.h>
#include <lcl/liostream.h>
#include <lcl/lthread.h>
#include <lcl/lstring.h>

/*!
 * \class LTraceFunc
 * \author Jens Reimann
 * \ingroup Tracing
 */

class LCL_EXPORT LTraceFunc {
 protected:
  static LHash<LThreadID, LHeap<LString> > stack;
  static LGuardMutex stackLock;

  char * name;
  char * fileName;
  unsigned long lineNumber;

 public:
  LTraceFunc ( const char *, const char *, unsigned long );
  ~LTraceFunc ();

  static void push ( LString const & );
  static void pop ( );
  static unsigned long getLevel ();
  static LHeap<LString> getStack ( LThreadID = LThread::currentID() );
  static void dumpStack ( LOStream & out, LThreadID = LThread::currentID() );
};

#endif
