/* -*-mode: c++; coding: iso-8859-2-unix; -*- */

#ifndef _LVARIANT_H_
#define _LVARIANT_H_

#include <lcl.h>

#include <lcl/lstring.h>
#include <lcl/lxcpt.h>

typedef struct _L_VAR_DATA
{
  LString data_string;
  
  union _numbers {
    lint8 data_int8;
    lint16 data_int16;
    lint32 data_int32;
    
    luint8 data_uint8;
    luint16 data_uint16;
    luint32 data_uint32;
    
    bool data_bool;
    double data_double;
  } numbers;

} L_VAR_DATA;

#define L_VAR_DATA_DT_INT8(data) ((data)->numbers.data_int8)
#define L_VAR_DATA_DT_INT16(data) ((data)->numbers.data_int16)
#define L_VAR_DATA_DT_INT32(data) ((data)->numbers.data_int32)
#define L_VAR_DATA_DT_UINT8(data) ((data)->numbers.data_uint8)
#define L_VAR_DATA_DT_UINT16(data) ((data)->numbers.data_uint16)
#define L_VAR_DATA_DT_UINT32(data) ((data)->numbers.data_uint32)
#define L_VAR_DATA_DT_BOOL(data) ((data)->numbers.data_bool)
#define L_VAR_DATA_DT_DOUBLE(data) ((data)->numbers.data_double)
#define L_VAR_DATA_DT_STRING(data) ((data)->data_string)


/*
 * Don't use the next macro!!!! It should not work and will not!!
 *
 *  Except for the shitty MSVC!! Which does not know what the code does,
 *  but compiles!!
 */
#define L_VAR_DATA_AS_DT(type,data) ( \
  ((type) == L_VAR_VALUE::DT_INT8) ? (L_VAR_DATA_DT_INT8((data))) : (\
  ((type) == L_VAR_VALUE::DT_INT16) ? (L_VAR_DATA_DT_INT16((data))) : (\
  ((type) == L_VAR_VALUE::DT_INT32) ? (L_VAR_DATA_DT_INT32((data))) : (\
\
  ((type) == L_VAR_VALUE::DT_UINT8) ? (L_VAR_DATA_DT_UINT8((data))) : (\
  ((type) == L_VAR_VALUE::DT_UINT16) ? (L_VAR_DATA_DT_UINT16((data))) : (\
  ((type) == L_VAR_VALUE::DT_UINT32) ? (L_VAR_DATA_DT_UINT32((data))) : (\
\
  ((type) == L_VAR_VALUE::DT_STRING) ? (L_VAR_DATA_DT_STRING((data))) : (\
  ((type) == L_VAR_VALUE::DT_BOOL) ? (L_VAR_DATA_DT_BOOL((data))) : (\
  ((type) == L_VAR_VALUE::DT_DOUBLE) ? (L_VAR_DATA_DT_DOUBLE((data))) : (\
\
  NULL \
   ))))))))))

#define L_VAR_DATA_AS_TYPE(vt,type,data) ( \
  ((type) == L_VAR_VALUE::DT_INT8) ? (vt)(L_VAR_DATA_DT_INT8((data))) : (\
  ((type) == L_VAR_VALUE::DT_INT16) ? (vt)(L_VAR_DATA_DT_INT16((data))) : (\
  ((type) == L_VAR_VALUE::DT_INT32) ? (vt)(L_VAR_DATA_DT_INT32((data))) : (\
\
  ((type) == L_VAR_VALUE::DT_UINT8) ? (vt)(L_VAR_DATA_DT_UINT8((data))) : (\
  ((type) == L_VAR_VALUE::DT_UINT16) ? (vt)(L_VAR_DATA_DT_UINT16((data))) : (\
  ((type) == L_VAR_VALUE::DT_UINT32) ? (vt)(L_VAR_DATA_DT_UINT32((data))) : (\
\
  ((type) == L_VAR_VALUE::DT_STRING) ? (vt)(L_VAR_DATA_DT_STRING((data))) : (\
  ((type) == L_VAR_VALUE::DT_BOOL) ? (vt)(L_VAR_DATA_DT_BOOL((data))) : (\
  ((type) == L_VAR_VALUE::DT_DOUBLE) ? (vt)(L_VAR_DATA_DT_DOUBLE((data))) : (\
\
  NULL \
   ))))))))))

typedef struct _L_VAR_VALUE
{
  enum DataType {
    DT_EMPTY,
    DT_STRING,
    DT_INT8,
    DT_INT16,
    DT_INT32,
    DT_UINT8,
    DT_UINT16,
    DT_UINT32,
    DT_BOOL,
    DT_DOUBLE
  };

  DataType data_type;

  L_VAR_DATA data;

} L_VAR_VALUE;

#define L_VAR_VALUE_TYPE(value) ((value)->data_type)

#define L_VAR_VALUE_DT_INT8(value) (L_VAR_DATA_DT_INT8(&((value)->data)))
#define L_VAR_VALUE_DT_INT16(value) (L_VAR_DATA_DT_INT16(&((value)->data)))
#define L_VAR_VALUE_DT_INT32(value) (L_VAR_DATA_DT_INT32(&((value)->data)))
#define L_VAR_VALUE_DT_UINT8(value) (L_VAR_DATA_DT_UINT8(&((value)->data)))
#define L_VAR_VALUE_DT_UINT16(value) (L_VAR_DATA_DT_UINT16(&((value)->data)))
#define L_VAR_VALUE_DT_UINT32(value) (L_VAR_DATA_DT_UINT32(&((value)->data)))
#define L_VAR_VALUE_DT_BOOL(value) (L_VAR_DATA_DT_BOOL(&((value)->data)))
#define L_VAR_VALUE_DT_DOUBLE(value) (L_VAR_DATA_DT_DOUBLE(&((value)->data)))
#define L_VAR_VALUE_DT_STRING(value) (L_VAR_DATA_DT_STRING(&((value)->data)))

#define L_VAR_VALUE_AS_DT(value) (L_VAR_DATA_AS_DT((value)->data_type, &((value)->data)))

#define L_VAR_VALUE_AS_TYPE(vt,value) (L_VAR_DATA_AS_TYPE((vt),(value)->data_type, &((value)->data)))


#define L_VAR_VALUE_CONVERT(type,value,defaultval,dsttype) \
 \
  switch ( L_VAR_VALUE_TYPE(value) ) \
    { \
 \
    case L_VAR_VALUE::DT_BOOL: \
      return (type)L_VAR_VALUE_DT_BOOL(value); \
       \
    case L_VAR_VALUE::DT_INT8: \
      return (type)L_VAR_VALUE_DT_INT8(value); \
    case L_VAR_VALUE::DT_INT16: \
      return (type)L_VAR_VALUE_DT_INT16(value); \
    case L_VAR_VALUE::DT_INT32: \
      return (type)L_VAR_VALUE_DT_INT32(value); \
 \
    case L_VAR_VALUE::DT_UINT8: \
      return (type)L_VAR_VALUE_DT_UINT8(value); \
    case L_VAR_VALUE::DT_UINT16: \
      return (type)L_VAR_VALUE_DT_UINT16(value); \
    case L_VAR_VALUE::DT_UINT32: \
      return (type)L_VAR_VALUE_DT_UINT32(value); \
 \
    case L_VAR_VALUE::DT_DOUBLE: \
      return (type)L_VAR_VALUE_DT_DOUBLE(value); \
 \
    case L_VAR_VALUE::DT_STRING: \
      return (type)L_VAR_VALUE_DT_STRING(value); \
 \
    case L_VAR_VALUE::DT_EMPTY: \
      return (defaultval); \
 \
    default: \
      throw LTypeMismatchException ( L_VAR_VALUE_TYPE(value), (dsttype), __FILE__, __LINE__ ); \
      break; \
    } \


LString dt2name ( L_VAR_VALUE::DataType type );

class LTypeMismatchException : public LBasicException {
protected:
  L_VAR_VALUE::DataType srcType, dstType;

public:
  LTypeMismatchException ( L_VAR_VALUE::DataType _srcType, L_VAR_VALUE::DataType _dstType, const char * _filename = __FILE__, unsigned long _line = __LINE__ );
  
  virtual void log () const;
};

class LCL_EXPORT LVariant {
public:

protected:
  L_VAR_VALUE m_value;

  void copyFrom ( LVariant const & p1 );

public:
  LVariant ();
  LVariant ( LVariant const & p1 );
  LVariant ( LString const & );
  LVariant ( bool );
  LVariant ( double );
  LVariant ( lint8 );
  LVariant ( lint16 );
  LVariant ( lint32 );
  LVariant ( luint8 );
  LVariant ( luint16 );
  LVariant ( luint32 );

  ~LVariant ();

  L_VAR_VALUE::DataType getType () const;

  void clear ();

  bool operator == ( LVariant const & p1 ) const;

  LVariant & operator = ( LVariant const & p1 );

  LVariant & operator = ( bool value );

  LVariant & operator = ( char const * value );
  LVariant & operator = ( LString const & value );

  LVariant & operator = ( lint8 value );
  LVariant & operator = ( lint16 value );
  LVariant & operator = ( lint32 value );

  LVariant & operator = ( luint8 value );
  LVariant & operator = ( luint16 value );
  LVariant & operator = ( luint32 value );

  LVariant & operator = ( double value );

  bool asBool () const;
  LString asString () const;

  luint8 asUInt8 () const;
  luint16 asUInt16 () const;
  luint32 asUInt32 () const;

  lint8 asInt8 () const;
  lint16 asInt16 () const;
  lint32 asInt32 () const;

  double asDouble () const;

  operator lint8 () const;
  operator lint16 () const;
  operator lint32 () const;
  operator luint8 () const;
  operator luint16 () const;
  operator luint32 () const;
  operator double () const;
  operator bool () const;
  operator LString () const;
  operator LString ();

  bool isBool () const;
  bool isString () const;
  bool isDouble () const;
};

LCL_EXPORT NAMESPACE_STD(ostream) & operator << ( NAMESPACE_STD(ostream) &, LVariant const & );
LCL_EXPORT LOStream & operator << ( LOStream &, LVariant const & );

#endif
