/* ****************************************************************************
   |      File: lcgi.cc
   |      Contains: class LCGI
   |      Created: 21.03.1998
   |      Last Changed: 26.03.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ************************************************************************* *
 * Change log:                                                               *
 * -------------                                                             *
 *                                                                           *
 *   -> [v0.00] - 21.03.1998 - Created file and started coding               * 
 *   -> [v0.00] - 03.09.1998 - Switched to new collection system             *
 * ************************************************************************* */


// **** LCL Includes

#include <lcl/lcgi.h>
#include <lcl/lconfparser.h>

#include <stdio.h>

LCGI::LCGI () :
  query ( new LCGIConfigParser () )
{
}

LCGI::LCGI ( LConfigParser * parser ) :
  query ( parser )
{
}

LString LCGI::method ()
{
  return LString::fromEnv("REQUEST_METHOD");
}

LString LCGI::docRoot ()
{
  return LString::fromEnv("DOCUMENT_ROOT");
}

LString LCGI::remoteHost ()
{
  return LString::fromEnv ( "REMOTE_HOST" );
}

LSockAddr4Inet LCGI::remoteAddr ()
{
  return LSockAddr4Inet ( LString::fromEnv("REMOVE_ADDR") );
  //  return LIP ( LString::fromEnv("REMOTE_ADDR") );
}

LString LCGI::referer ()
{
  return LString::fromEnv ( "HTTP_REFERER" );
}

int LCGI::has ( LString const & key )
{
  return query.first("query").get(key) != "";
}

LString LCGI::get ( LString const & key )
{
  LString str;
  try {
    str = query.first("query").get(key);
    return str;
  }
  catch (...) {
    return LString();
  }
}

void LCGI::sendHeader ( LString const & contentType )
{
  NAMESPACE_STD(cout) << "Content-type: " << contentType << "\n";

  NAMESPACE_STD(cout) << "\n";
}

void LCGI::sendHeader ( LString const & contentType, unsigned long size, LString const & add )
{
  NAMESPACE_STD(cout) << "Content-type: " << contentType << "\n";
  NAMESPACE_STD(cout) << "Content-length: " << size << "\n";

  NAMESPACE_STD(cout) << add;

  NAMESPACE_STD(cout) << "\n\n";
}

void LCGI::sendHeader ( LString const & contentType, LBuffer & buffer, LString const & add )
{
  NAMESPACE_STD(cout) << "Content-type: " << contentType << "\n";
  NAMESPACE_STD(cout) << "Content-length: " << buffer.getSize() << "\n";

  NAMESPACE_STD(cout) << add;

  NAMESPACE_STD(cout) << "\n\n";
}

void LCGI::sendContent ( LBuffer const & buffer )
{
  NAMESPACE_STD(cout) << buffer;
}

void LCGI::sendFile ( LString const & fileName, \
		 LString const & p1, LString const & p2, LString const & p3, LString const & p4, LString const & p5, \
		 LString const & p6, LString const & p7, LString const & p8, LString const & p9 )

{
  NAMESPACE_STD(cout) << "\n<!-- Sending file " << fileName << " -->\n";

  FILE * fp = fopen ( fileName, "r" );
 
  if ( fp == NULL ) {

    NAMESPACE_STD(cout) << "<H1>File " << fileName << " not found!</H1>";
    /*    if (inform != "")
	  NAMESPACE_STD(cout) << "<BR>Please inform <A HREF=\"" << inform << "\">" << inform << "</A><BR><BR>Thanks!!";*/

  } else {

    char c;
    
    while (!feof(fp)) {
      c = fgetc ( fp );
      if (!feof(fp))
	if ( c != '%' )
	  NAMESPACE_STD(cout) << c;
	else {
	  c = fgetc( fp );
	  if ( (c>='1') && (c<='9')) {

	    switch (c-'1') {
	    case 0:
	      NAMESPACE_STD(cout) << p1;
	      break;
	    case 1:
	      NAMESPACE_STD(cout) << p2;
	      break;
	    case 2:
	      NAMESPACE_STD(cout) << p3;
	      break;
	    case 3:
	      NAMESPACE_STD(cout) << p4;
	      break;
	    case 4:
	      NAMESPACE_STD(cout) << p5;
	      break;
	    case 5:
	      NAMESPACE_STD(cout) << p6;
	      break;
	    case 6:
	      NAMESPACE_STD(cout) << p7;
	      break;
	    case 7:
	      NAMESPACE_STD(cout) << p8;
	      break;
	    case 8:
	      NAMESPACE_STD(cout) << p9;
	      break;
	    }
	  } else {
	    NAMESPACE_STD(cout) << "%" << c;
	  }
	}
    }

    fclose ( fp );
  }
}
