#include <lcl/lconfmodule.h>

#include <lcl/lfstream.h>

class ConfigWriterIter_default_2 : public LHashIterator < LString, LString > {
public:
  LOStream * stream;
  void applyTo ( LString & _key, LString & _value ) {
    LString key = _key;
    LString value = _value;
    key.change ( "\\", "\\\\" );
    key.change ( ":", "\\:" );
    key.change ( ";", "\\;" );
    key.change ( "{", "\\{" );
    key.change ( "}", "\\}" );
    value.change ( "\\", "\\\\" );
    value.change ( ":", "\\:" );
    value.change ( ";", "\\;" );
    value.change ( "{", "\\{" );
    value.change ( "}", "\\}" );
    (*stream) << "  " << key << ":" << value << ";" << endl;
  }
};

class ConfigWriterIter_default_1 : public LIterator < LConfigObject > {
public:
  LOStream * stream;
  ConfigWriterIter_default_2 cwi;

  void applyTo ( LConfigObject & obj )
  {
    (*stream) << obj.getType() << " {" << endl;
    cwi.stream = stream;
    obj.getHash().allElementsDo ( cwi );
    (*stream) << "}" << endl << endl;
  }
};

LConfigWriter_default::LConfigWriter_default ( LOStream & _stream ) :
  stream ( _stream )
{
}

void LConfigWriter_default::write ( LConfigSystem & config ) const
{
  ConfigWriterIter_default_1 cwi;
  cwi.stream = &stream;
  config.forEach ( cwi );
}

LConfigReader_default::LConfigReader_default ( LIStream & _stream ) :
  stream ( &_stream )
{
}

LConfigReader_default::LConfigReader_default ( LString const & fileName ) :
  stream ( NULL  )
{
  myFile = new LFile ( fileName, LFDManager::read );
  myStream = new LFIStream ( *myFile );
  stream = myStream;
}


void LConfigReader_default::read ( LConfigSystem & config ) const
{
  config.clear ();
  config.read ( new LDefaultConfigParser ( *stream, "#" ) );
}

