#include <lcl/lcrypt.xor.h>

#include <lcl/ltrace.h>

LVCS_INIT(LCryptModule_XOR);

void LCryptModule_XOR::apply ( LBuffer & data )
{
  LBuffer key_data = key.get ();
  unsigned long i;
  unsigned long j;

  LTRACE ( "LCryptModule_XOR", "key size: " + LString(key_data.getSize()) );
  LTRACE ( "LCryptModule_XOR", "data size: " + LString(data.getSize()) );

  for ( i = 0, j=0; i < data.getSize(); i++, j++ ) {

    if ( j >= key_data.getSize() )
      j = 0;

    LTRACE ( "LCryptModuel_XOR.trace", "i = " + LString(i) + ", j = " + LString(j) );

    data[i] = data[i] ^ key_data[j];

  }
}

LCryptModule_XOR::LCryptModule_XOR ( LCryptSecretKey const & _key ) :
  LCryptSymModule ( _key )
{
}

void LCryptModule_XOR::encode ( LBuffer & data )
{
  apply ( data );
}

void LCryptModule_XOR::decode ( LBuffer & data )
{
  apply ( data );
}
