#include <lcl/ldatetime.h>

//LVCS_INIT(LDateTime);

LDateTime::LDateTime ()
{
  value = 0;
}

LDateTime::LDateTime ( time_t _value )
{
  value = _value;
}

LDateTime::LDateTime ( LString const & timestr, LString const format )
{
  
}

LDateTime::LDateTime ( tm _tm )
{
  value = mktime ( &_tm );
}

LDateTime::LDateTime ( tm * _tm )
{
  value = mktime ( _tm );
}

LDateTime LDateTime::now ()
{
   return time(0);
}

long LDateTime::getHours () const
{
  return localtime(&value)->tm_hour;
}
void LDateTime::setHours ( long val )
{
  tm * _tm = gmtime ( &value );
  _tm->tm_hour = val;
  value = mktime ( _tm );
}

long LDateTime::getMinutes () const
{
  return gmtime(&value)->tm_min;
}
void LDateTime::setMinutes ( long val )
{
  tm * _tm = gmtime ( &value );
  _tm->tm_min = val;
  value = mktime ( _tm );
}

long LDateTime::getSeconds () const
{
  return gmtime(&value)->tm_sec;
}
void LDateTime::setSeconds ( long val )
{
  tm * _tm = gmtime ( &value );
  _tm->tm_sec = val;
  value = mktime ( _tm );
}

long LDateTime::getYear () const
{
  return gmtime(&value)->tm_year+1900;
}
void LDateTime::setYear ( long val )
{
  tm _tm = *gmtime ( &value );
  _tm.tm_year = (val - 1900);
  value = mktime ( &_tm );
}

long LDateTime::getMonth () const
{
  return gmtime(&value)->tm_mon+1;
}
void LDateTime::setMonth ( long val )
{
  tm * _tm = gmtime ( &value );
  _tm->tm_mon = (val-1);
  value = mktime ( _tm );
}

long LDateTime::getDayOfYear () const
{
  return gmtime(&value)->tm_yday;
}

long LDateTime::getDay () const
{
  return gmtime(&value)->tm_mday;
}
void LDateTime::setDay ( long val )
{
  tm * _tm = gmtime ( &value );
  _tm->tm_mday = val;
  value = mktime ( _tm );
}


long LDateTime::inSeconds () const
{
  return value;
}
long LDateTime::inMinutes () const
{
  return value/60;
}
long LDateTime::inHours () const
{
  return value/3600;
}
long LDateTime::inDays () const
{
  return value/(3600*24);
}
long LDateTime::inMonths () const
{
  return value/(3600*24*30);
}
long LDateTime::inYears () const
{
  return value/(3600*24*30*12);
}


LDateTime::operator time_t() const
{
  return value;
}
LDateTime::operator time_t*()
{
  return &value;
}
LDateTime::operator tm () const
{
  tm * _tm = gmtime ( &value );
  return *_tm;
}
LDateTime::operator tm * () const
{
  return gmtime ( &value );
}

LDateTime LDateTime::operator- (LDateTime const &  p1) const
{
  return difftime ( value, p1.value );
}

LString LDateTime::asString ( LString const & format ) const
{  
  if ( !format.length() ) {
    return LString(ctime ( &value )).removeLastChar();
  } else {
    char buffer[4*1024];
    strftime ( buffer, sizeof(buffer), format, localtime ( &value ) );
    return buffer;
  }
}

void LDateTime::dump () const
{
  NAMESPACE_STD(cout) << ctime ( &value );
}
