#include <lcl/lemitx.h>

LBasicSlot::LBasicSlot () :
  active ( true )
{
}

void LBasicSlot::disconnect ( void )
{
  active = false;
}

bool LBasicSlot::isActive () const
{
  return active;
}

LBasicSlot::~LBasicSlot ()
{
}

// LBasicEmitter

LSlotConnection LBasicEmitter::addSlot ( LManagedPointer < LBasicSlot > slot )
{
  callbackList.add ( slot );
  return LSlotConnection ( slot );
}

void LBasicEmitter::removeSlot ( LManagedPointer < LBasicSlot > slot )
{
  callbackList.removeElement ( slot );
}

LBasicEmitter::~LBasicEmitter ()
{
}

// LSlotConnection

LSlotConnection::LSlotConnection ( )
{
}

LSlotConnection::LSlotConnection ( LManagedPointer<LBasicSlot> _slot ) :
  slot ( _slot )
{
}

void LSlotConnection::disconnect ( void )
{
  if ( !slot.isValid () )
    return;
  
  slot->disconnect ();
}

LSlotConnection::~LSlotConnection ()
{
}
