
#include <lcl/lfallback_mutex.h>

__lcl_fallbackGuardMutex::__lcl_fallbackGuardMutex () :
  m_count ( 0 )
{
}

__lcl_fallbackGuardMutex::~__lcl_fallbackGuardMutex ()
{  
}

bool __lcl_fallbackGuardMutex::lock ()
{
  m_controlLock.lock ();

  if ( m_count ) 
    {
      if ( m_owner == LGetCurrentThreadID() )
	{
	  m_count++;
	  m_controlLock.unlock ();
	  return true;
	}
    }

  m_controlLock.unlock ();

  while ( true )
    {
      m_controlLock.lock ();
      if ( (m_count == 0) )
	{
	  m_count = 1;
	  m_owner = LGetCurrentThreadID();
	  m_controlLock.unlock ();
	  return true;
	}
      m_controlLock.unlock ();
      lcl_usleep (1);
    }

  /*
  m_lock.lock ();
  m_owner = LGetCurrentThreadID();
  m_count = 1;
  */

  return true;
}

bool __lcl_fallbackGuardMutex::unlock ()
{
  m_controlLock.lock ();

  if ( m_owner != LGetCurrentThreadID() )
    return false;

  if ( m_count == 0 )
    return false;

  m_count--;
  //  if ( m_count == 0 )
  //    m_lock.unlock ();
  m_controlLock.unlock ();
  return true;
}

bool __lcl_fallbackGuardMutex::trylock ()
{
  m_controlLock.lock ();
  if ( m_count )
    {
      if ( m_owner == LGetCurrentThreadID() )
	{
	  m_count++;
	  m_controlLock.unlock ();
	  return true;
	}
    }

  if ( m_count == 0  )
    {
      m_count = 1;
      m_owner = LGetCurrentThreadID();
      m_controlLock.unlock ();
      return true;
    }
  else
    {
      m_controlLock.unlock ();
      return false;
    }

  /*
  if ( m_lock.trylock () )
    {
      m_owner = LGetCurrentThreadID();
      m_count = 1;
      m_controlLock.unlock ();  
      return true;
    }
  else
    {
      m_controlLock.unlock ();
      return false;
    }
  */
}
