

#include <lcl/lrevision.h>
#include <lcl/lstreamproxy.h>
#include <lcl/lfdlayer.common.h>

LREVISION("LFDManager", fd_rev10, "1.0", "Initial Revision" );

LFDManagerException::LFDManagerException ( const char * _filename, unsigned long _line, ErrorCode _rc, LFileDescriptor _fd ) :
  LBasicException ( _filename, _line ),
  rc ( _rc ),
  fd ( _fd )
{
}

void LFDManagerException::log ( ) const
{
  LString reason = "<unkown>";

  switch ( rc ) {
  case invalidFD:
    reason = "invalid file descriptor: " + LString(fd);
    break;
  }

  LBasicException::log ();
  lerr << " >> LCL FileDesc Manager Exception" << endl;
  lerr << "  >> Reason: " << reason << endl;
  lerr << flush;
}
