
#include <lcl/lmath.h>

#include <math.h>

/*!
 *
 * Round a floating point value
 *
 * \code

double d;
d = lcl_round ( 0.49 );     // d = 0
d = lcl_round ( 0.5 );      // d = 1
d = lcl_round ( -0.49 );    // d = 0
d = lcl_round ( -0.5 );     // d = -1
d = lcl_round ( 0.444441 ); // d = 0
d = lcl_round ( 0.444445 ); // d = 1

\endcode
 *
 * \param value the value to round
 * \return the rounded value
 */

LCL_EXPORT double lcl_round ( double value )
{
  if ( value == 0 )
    return 0;
  if ( value > 0 )
    {
      return ((value-floor(value)) >= 0.5 ) ? ceil(value) : floor (value);
    }
  if ( value < 0 )
    {
      return ((fabs(value-ceil(value))) >= 0.5 ) ? floor(value) : ceil (value);
    }
  return 0;
}
