#include <lcl/lsockaddr.unix.h>

LString LSockAddrUnix::nameLookup () const
{
  return un_addr.sun_path;
}

LString LSockAddrUnix::numLookup () const
{
  return un_addr.sun_path;
}


LSockAddrUnix::LSockAddrUnix ()
{
  memset ( &un_addr, 0, sizeof (un_addr) );
  un_addr.sun_family = AF_UNIX;
}

LSockAddrUnix::LSockAddrUnix ( LString const & _addr )
{
  memset ( &un_addr, 0, sizeof (un_addr) );

  un_addr.sun_family = AF_UNIX;
  strcpy ( un_addr.sun_path, _addr );

  nameLookupCache = nameLookup ();
}

LSockAddrUnix::LSockAddrUnix ( sockaddr_un const * _addr )
{

  memset ( &un_addr, 0, sizeof (un_addr) );
  un_addr.sun_family = AF_UNIX;

  if ( _addr->sun_family != AF_UNIX )
    return;

  memcpy ( &un_addr, _addr, sizeof(un_addr) );

  nameLookupCache = nameLookup ();
}

LSockAddrUnix::operator sockaddr () const
{
  return *(sockaddr*)&un_addr;
}

LSockAddrUnix::operator sockaddr* ()
{
  return (sockaddr*)&un_addr;
}

LSockAddrUnix::operator sockaddr const * () const
{
  return (sockaddr const *)&un_addr;
}

L_ADDRLEN_T LSockAddrUnix::length () const
{
  return sizeof(un_addr.sun_family) + strlen(un_addr.sun_path);
}

LString LSockAddrUnix::dump () const
{
  return asString();
}
