#include <lcl/lstreamproxy.h>

#include <iostream.h>

LCL_EXPORT LOStreamProxy lout ( cout );
LCL_EXPORT LOStreamProxy lerr ( cerr );
LCL_EXPORT LIStreamProxy lin ( cin );

LIStreamProxy::LIStreamProxy ( istream & _in ) :
  in_stream ( _in )
{
}

int LIStreamProxy::read ( char & c )
{
  if ( ! in_stream )
    throw LEndOfStreamException ( *this );

  if ( in_stream.eof() )
    throw LEndOfStreamException ( *this );

  in_stream.get ( c );

  int len = in_stream.gcount ();

  if ( len == 0 )
    throw LEndOfStreamException ( *this );


  /*
  if ( in_stream.eof() )
    throw LEndOfStreamException ( *this );
  */

  return true;
}

int LIStreamProxy::read ( void * ptr, unsigned long size )
{
  if ( ! in_stream )
    throw LEndOfStreamException ( *this );

  if ( in_stream.eof() )
    throw LEndOfStreamException ( *this );
  
  in_stream.read ( (char*)ptr, size );
  int len = in_stream.gcount ();
  if ( len == 0 )
    throw LEndOfStreamException ( *this );

  /*
  if ( in_stream.eof() )
    throw LEndOfStreamException ( *this );
  */

  return len;
}

/*
bool LIStreamProxy::mayRead ( )
{
  return in_stream.good();
}
*/

LOStreamProxy::LOStreamProxy ( ostream & _out ) :
  out_stream ( _out )
{
}

int LOStreamProxy::write ( char c )
{
  out_stream.put ( c );
  return true;
}

int LOStreamProxy::write ( void * const ptr, unsigned long size )
{
  out_stream.write ( (const char*)ptr, size );
  return true;
}

/*
bool LOStreamProxy::mayWrite ( )
{
  return out_stream.good();
}
*/

void LOStreamProxy::flush ()
{
  out_stream.flush ();
}

LIOStreamProxy::LIOStreamProxy ( iostream & _iostream ) :
  LIStreamProxy ( _iostream ),
  LOStreamProxy ( _iostream ),
  inout_stream ( _iostream )
{
}
