/* ****************************************************************************
   |      File: lurl.cc
   |      Contains: class LURL
   |      Created: 04.05.1998
   |      Last Changed: 04.05.1998
   |      Version: 0.0
   |         
   |      ToDo: + just started
   |
   ************************************************************************* */

/* ************************************************************************* *
 * Change log:                                                               *
 * -------------                                                             *
 *                                                                           *
 *   -> [v0.00] - 04.05.1998 - Created file and started coding               * 
 * ************************************************************************* */


// **** LCL Includes

#include <lcl/lurl.h>

#include <lcl/lregex.h>

LURL::LURL ()
{
  port = 0;
  valid = false;
}

LURL::LURL ( LString const & uri )
{
  LRegEx exp ( "^(http://)\?([a-zA-Z0-9\\.\\-]*)\?:\?([0-9]*)\?([^\\?]*)\\\?\?(.*)$" );
  // trigraphs ... !!
  //  LRegEx exp ( "^(http://)?([a-zA-Z0-9\\.\\-]*)?:?([0-9]*)?([^\\?]*)\\??(.*)$" );

  if ( exp.exec ( uri ) ) {
    valid = true;
    proto = exp.match ( 1 );
    host = exp.match ( 2 );
    port = exp.match ( 3 );
    path = exp.match ( 4 );
    query = exp.match ( 5 );
    
  } else {
    valid = false;
  }
}
