
#include <lcl_common.h>

void replace_and_dump ( LString const & str, LHash<LString,LString> const & data )
{
  lout << str.replace ( data ); << endl;
}

int  main ( int argc, char * argv[] )
{
  try
    {

      // Init Application
      theApp.init ( argc, argv );
      theApp.processLCLParameters ();
      
      // Create a new hash table
      LHash<LString,LString> testHash;

      // set some data
      testHash.set ( "NAME", "Arthur Dent" );
      testHash.set ( "PLANET", "Earth" );
      replace_and_dump ( "Hello my name is: $(NAME) and I live on $(PLANET)!" );
      replace_and_dump ( "Hello my name is: $(NAME) and I live on $(NOT_DEFINED)!" );

      testHash.set ( "NAME", "Trillian" );
      replace_and_dump ( "Hello my name is: $(NAME) and I live on $(NOT_DEFINED)!" );

      testHash.set ( "NAME", "Mr. X" );
      testHash.unset ( "PLANET" );
      replace_and_dump ( "Hello my name is: $(NAME) and I live on $(NOT_DEFINED?-<unkown>)!" );

      testHash.set ( "LOCATION", "an unkown city" );
      replace_and_dump ( "Hello my name is: $(NAME) and I live on $(PLANET:-no planet but in $(LOCATION))!" );

      testHash.set ( "The name $(NAME) has $(#NAME) characters" );
    }

  catch ( LBasicException & e )
    {
      e.log ();
      return 1;
    }

  return 0;
}
