#include <ldbsystem.h>

#include <lcl_config.h>
#ifdef HAVE_LIBODBC

#define WIN32
#include <windows.h>
#include <SQL.H>
#include <SQLEXT.H>

class LDBQuery_ODBC;

class LCL_EXPORT_PLUGIN LDBDriver_ODBC : public LDBDriver {
  LHash<LString,LString> configHash;

  friend class LDBQuery_ODBC;

 protected:  

  bool valid;
  HDBC hdbc;
  HENV henv;

  LString getLastODBCError () const;

 public:

  virtual LManagedPointer<LDBQuery> createQuery ();

  LDBDriver_ODBC ( LHash<LString,LString> const & vars );
  ~LDBDriver_ODBC ();

  //  LDBQuery * query ( LString const & );

  virtual bool connect ();
  virtual bool disconnect ();

  virtual bool connected () const;

};

class LDBQuery_ODBC : public LDBQuery {
 protected:

  LDBDriver_ODBC & driver;
  HSTMT hstmt;
  unsigned long rowCount;
  LHash <LString,LString> internalHash;

  LString sys_getField ( long ) const;

  LString getLastODBCError () const;

 public:
  LDBQuery_ODBC ( LDBDriver_ODBC & );
  LDBQuery_ODBC ( LDBDriver_ODBC &, LString const & sql );
  virtual ~LDBQuery_ODBC ();

  //  virtual bool prepare ( LString const & );
  //  virtual bool exec ();
  virtual bool exec ( LString const & );
  //  virtual bool exec ( LHash<LString, LString> const & );

  virtual long numFields () const;
  virtual long numRows () const;

  virtual bool fetchNext ( LHash<LString, LString> & );
  virtual bool fetchNext ();
          
  virtual LString getField ( long ) const;
  virtual LString getField ( LString const& ) const;

  virtual LString getFieldName ( long ) const;
  virtual long getFieldIdx ( LString const & ) const;

  // liefert exec-wert zurck
  virtual bool hasResult () const;
};


#endif // HAVE_ODBC
